const fs = require('fs');

fs.readdirSync('src/').forEach(fileName => {
	const orgContent = fs.readFileSync(`src/${fileName}`, 'utf8').replace(/from '\.\.\//g, 'from \'../../');
	fs.writeFileSync(`generated/cov-env/${fileName}`, orgContent);
	if (!fileName.includes('.test')) return;
	fs.writeFileSync(`generated/minified/${fileName}`, orgContent);
	const allJsTest = orgContent.replace(
		/import \* as app from '\.\/(crypto)\.mjs';/,
		(full, libName) => `import {${libName} as app} from './all.mjs';`);
	fs.writeFileSync(`generated/cov-env/all.${fileName}`, allJsTest);
	fs.writeFileSync(`generated/minified/all.${fileName}`, allJsTest);
});
fs.writeFileSync('generated/cov-env/package.json', fs.readFileSync('package.json', 'utf8'));
